Shader "HoverBox"
{
	Properties 
	{
_Underlay("_Underlay", 2D) = "white" {}
_Color("_Color", Color) = (1,1,1,1)
_Overlay("_Overlay", 2D) = "white" {}
_Normal("_Normal", 2D) = "white" {}
_Emission("_Emission", Float) = 0.25
_Emissive("_Emissive", 2D) = "white" {}
_EmissionRange("_EmissionRange", Float) = 40

	}
	
	SubShader 
	{
		Tags
		{
"Queue"="Geometry"
"IgnoreProjector"="False"
"RenderType"="Opaque"

		}

		
Cull Back
ZWrite On
ZTest LEqual


		CGPROGRAM
#pragma surface surf BlinnPhongEditor  vertex:vert
#pragma target 2.0


sampler2D _Underlay;
float4 _Color;
sampler2D _Overlay;
sampler2D _Normal;
float _Emission;
sampler2D _Emissive;
float _EmissionRange;

			struct EditorSurfaceOutput {
				half3 Albedo;
				half3 Normal;
				half3 Emission;
				half3 Gloss;
				half Specular;
				half Alpha;
			};
			
			inline half4 LightingBlinnPhongEditor_PrePass (EditorSurfaceOutput s, half4 light)
			{
half3 spec = light.a * s.Gloss;
half4 c;
c.rgb = (s.Albedo * light.rgb + light.rgb * spec);
c.a = s.Alpha + Luminance(spec);
return c;

			}

			inline half4 LightingBlinnPhongEditor (EditorSurfaceOutput s, half3 lightDir, half3 viewDir, half atten)
			{
				viewDir = normalize(viewDir);
				half3 h = normalize (lightDir + viewDir);
				
				half diff = max (0, dot (s.Normal, lightDir));
				
				float nh = max (0, dot (s.Normal, h));
				float3 spec = pow (nh, s.Specular*128.0) * s.Gloss;
				
				half4 res;
				res.rgb = _LightColor0.rgb * (diff * atten * 2.0);
				res.w = spec * Luminance (_LightColor0.rgb);

				return LightingBlinnPhongEditor_PrePass( s, res );
			}
			
			struct Input {
				float2 uv_Underlay;
float2 uv_Overlay;
float2 uv_Normal;
float2 uv_Emissive;
float4 screenPos;

			};


			void vert (inout appdata_full v, out Input o) {
float4 VertexOutputMaster0_0_NoInput = float4(0,0,0,0);
float4 VertexOutputMaster0_1_NoInput = float4(0,0,0,0);
float4 VertexOutputMaster0_2_NoInput = float4(0,0,0,0);
float4 VertexOutputMaster0_3_NoInput = float4(0,0,0,0);


			}
			

			void surf (Input IN, inout EditorSurfaceOutput o) {
				o.Albedo = 0.0;
				o.Normal = float3(0.0,0.0,1.0);
				o.Emission = 0.0;
				o.Gloss = 0.0;
				o.Specular = 0.0;
				o.Alpha = 1.0;
float4 Sampled2D0=tex2D(_Underlay,IN.uv_Underlay.xy);
float4 Multiply0=Sampled2D0 * _Color;
float4 Sampled2D1=tex2D(_Overlay,IN.uv_Overlay.xy);
float4 Lerp0=lerp(Multiply0,Sampled2D1,float4( Sampled2D1.a));
float4 Sampled2D2=tex2D(_Normal,IN.uv_Normal.xy);
float4 Sampled2D3=tex2D(_Emissive,IN.uv_Emissive.xy);
float4 Multiply1=float4( Sampled2D3.a) * _Color;
float4 Multiply2=float4(_Emission) * Multiply1;
float4 Splat0=IN.screenPos.z;
float4 Divide0=Splat0 / float4(_EmissionRange);
float4 Saturate0=saturate(Divide0);
float4 Invert0= float4(1.0) - Saturate0;
float4 Multiply3=Multiply2 * Invert0;
float4 Master0_3_NoInput = float4(0,0,0,0);
float4 Master0_4_NoInput = float4(0,0,0,0);
float4 Master0_5_NoInput = float4(1,1,1,1);
float4 Master0_6_NoInput = float4(1,1,1,1);
o.Albedo = Lerp0;
o.Normal = Sampled2D2;
o.Emission = Multiply3;
o.Alpha = 1.0;

			}
		ENDCG
	}
	Fallback "Diffuse"
}